<?xml version="1.0" encoding="utf-8"?>
<s:Group xmlns:fx="http://ns.adobe.com/mxml/2009" 
		 xmlns:s="library://ns.adobe.com/flex/spark" 
		 xmlns:mx="library://ns.adobe.com/flex/mx" xmlns:visual="br.com.desenv.framework.component.visual.*" 
		 creationComplete="creationCompleteHandler(event)">
	
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	<fx:Metadata>
		[Event(name="LOAD_COMPLETE", type="flash.events.Event")]
		[Event(name="INDEX_CHANGE", type="spark.events.IndexChangeEvent")]
	</fx:Metadata>
	
	<fx:Script>
		<![CDATA[
			
			import mx.core.FlexGlobals;
			import mx.events.FlexEvent;
			
			
			
			import spark.events.IndexChangeEvent;
			
			import br.com.desenv.nepalign.vo.EmpresaFinanceiro;
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;

			[Bindable]
			private var listaEmpresaFinanceiro:ArrayCollection;
			
			public static const LOAD_COMPLETE_EVENT:String = "LOAD_COMPLETE";
			public static const INDEX_CHANGE_EVENT:String = "INDEX_CHANGE";
			
			public static const LISTAR_TODAS_EMPRESAS:Number = 0x00;
			public static const LISTAR_APENAS_CHEQUE:Number = 0x01;
			public static const LISTAR_APENAS_CARTAO:Number = 0x02;
			public static const LISTAR_APENAS_VALE:Number = 0x03;
			public static const LISTAR_CHEQUE_VALE:Number = 0x0A;
			
			public var tipoPesquisa:Number = 0x00;
			
			override public function setFocus():void
			{
				ignComboBoxAutoCompleteEmpresaFinanceiro.setFocus();
			}
			
			override public function set enabled(value:Boolean):void
			{
				callLater(function():void
				{
					ignComboBoxAutoCompleteEmpresaFinanceiro.enabled = value;
				});
				super.enabled = value;
			}
			
			public function set obrigatorio(value:Boolean):void
			{
				ignComboBoxAutoCompleteEmpresaFinanceiro.obrigatorio = value;
			}
			
			public function get obrigatorio():Boolean
			{
				return ignComboBoxAutoCompleteEmpresaFinanceiro.obrigatorio;
			}
			
			override public function set percentWidth(value:Number):void
			{
				ignComboBoxAutoCompleteEmpresaFinanceiro.percentWidth = value;
				super.percentWidth = value;
			}
			
			override public function set width(value:Number):void
			{
				ignComboBoxAutoCompleteEmpresaFinanceiro.width = value;
				super.width = value;
			}
			
			protected function creationCompleteHandler(event:FlexEvent):void
			{
				addEventListener(FocusEvent.FOCUS_IN, focusInEventHandler);
				ignComboBoxAutoCompleteEmpresaFinanceiro.addEventListener(IndexChangeEvent.CHANGE, ignComboBoxAutoCompleteEmpresaFinanceiro_changeHandler);
				
				var empresaFinanceiroFiltro:EmpresaFinanceiro = new EmpresaFinanceiro();
				
				if(tipoPesquisa != 0x00 && tipoPesquisa != LISTAR_CHEQUE_VALE)
					empresaFinanceiroFiltro.tipoEmpresa = tipoPesquisa;
				
				AMFConnector.instance.prepararObjetoRemoto("empresaFinanceiroService", listarEmpresaFinanceiroResultHandler).getOperation("listarPorObjetoFiltro").send(empresaFinanceiroFiltro);
			}
			
			protected function listarEmpresaFinanceiroResultHandler(event:ResultEvent):void
			{
				if(FlexGlobals.topLevelApplication.usuarioLogado.usuarioMaster == "S")
					listaEmpresaFinanceiro = event.result as ArrayCollection;
				else
				{
					listaEmpresaFinanceiro = new ArrayCollection();
					
					for each(var empresaFinanceiro:EmpresaFinanceiro in event.result as ArrayCollection)
					{
						if(tipoPesquisa == LISTAR_CHEQUE_VALE && empresaFinanceiro.tipoEmpresa != LISTAR_APENAS_CHEQUE && empresaFinanceiro.tipoEmpresa != LISTAR_APENAS_VALE)
							continue;
						
						if(empresaFinanceiro.empresaFisicaReferente.id == FlexGlobals.topLevelApplication.usuarioLogado.empresaPadrao.id)
							listaEmpresaFinanceiro.addItem(empresaFinanceiro);
					}
				}
				
				listaEmpresaFinanceiro.addItemAt(null, 0x00);
			}
			
			protected function focusInEventHandler(event:FocusEvent):void
			{
				ignComboBoxAutoCompleteEmpresaFinanceiro.setFocus();	
			}
			
			protected function ignComboBoxAutoCompleteEmpresaFinanceiro_changeHandler(event:IndexChangeEvent):void
			{
				dispatchEvent(new IndexChangeEvent(INDEX_CHANGE_EVENT));
			}
			
			public function get selectedItem():*
			{
				try
				{
					return ignComboBoxAutoCompleteEmpresaFinanceiro.selectedItem;
				}
				catch(e:Error)
				{
					return null;
				}
				return null;
			}
			
			public function set selectedItem(obj:*):void
			{
				try
				{
					ignComboBoxAutoCompleteEmpresaFinanceiro.selectedItem = obj;
				}
				catch(e:Error)
				{
					throw e;	
				}
			}
			
			public function set selectedIndex(index:Number):void
			{
				try
				{
					ignComboBoxAutoCompleteEmpresaFinanceiro.selectedIndex = index;
				}
				catch(e:Error)
				{
					throw e;
				}
			}

			override public function get errorString():String
			{
				return ignComboBoxAutoCompleteEmpresaFinanceiro.errorString;
			}
			
			protected function ignComboBoxAutoCompleteEmpresaFinanceiro_keyDownHandler(event:KeyboardEvent):void
			{
				if(event.keyCode != Keyboard.ENTER)
					return;
				if(ignComboBoxAutoCompleteEmpresaFinanceiro.textInput.text == "")
					return;
				
				var id:Number = Number(ignComboBoxAutoCompleteEmpresaFinanceiro.textInput.text);
				
				if(isNaN(id))
					return;
				
				for(var index:int = 0x00; index < listaEmpresaFinanceiro.length; index++)
				{
					if(id == (listaEmpresaFinanceiro.getItemAt(index) as EmpresaFinanceiro).id)
					{
						ignComboBoxAutoCompleteEmpresaFinanceiro.selectedIndex = index;
						break;
					}
				}
			}
			
		]]>
	</fx:Script>
	
	<s:HGroup width="100%" height="100%">
		<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteEmpresaFinanceiro" keyDown="ignComboBoxAutoCompleteEmpresaFinanceiro_keyDownHandler(event)" labelField="nomeConcatenado" dataProvider="{listaEmpresaFinanceiro}"/>
	</s:HGroup>
</s:Group>
